var elements = new Array("nodes","ways");

function viewValuesFromKey(key) {
	
	if (key=="osmarender_frontend:null") return false;
	
	var div_result = document.getElementById("result_process_osm");

	if (document.getElementById("label_feature_value")) {
		div_result.removeChild(document.getElementById("label_feature_value"));
		div_result.removeChild(document.getElementById("select_feature_value"));
		div_result.removeChild(document.getElementById("label_feature_rule"));
		div_result.removeChild(document.getElementById("select_feature_rule"));
	}

	var label_container = document.createElement("label");
	label_container.setAttribute("id","label_feature_value");
	label_container.setAttribute("for","select_feature_value");
	var label = document.createTextNode("Select value: ");
	label_container.appendChild(label);
	div_result.appendChild(label_container);
	
	var select_ways_value = document.createElement("select");
	select_ways_value.setAttribute("id","select_feature_value");
	
	var sorted_list_of_unique_values = new Array();
	
	for (var dettaglio in elements.ways) {
		for (var tag in elements.ways[dettaglio]) {
			if (tag == key) {
				sorted_list_of_unique_values[sorted_list_of_unique_values.length] = elements.ways[dettaglio][tag];
			}
		}
	}
	
	sorted_list_of_unique_values = RemoveDuplicates(sorted_list_of_unique_values.sort());
	
	for (var value_name in sorted_list_of_unique_values) {
			var new_option = document.createElement("option");
			new_option.setAttribute("value",sorted_list_of_unique_values[value_name]);
			var new_option_text = document.createTextNode(sorted_list_of_unique_values[value_name]);
			new_option.appendChild(new_option_text);
			select_ways_value.appendChild(new_option);
	}
	
	div_result.appendChild(select_ways_value);
	
	var label_rule = document.createElement("label");
	label_rule.setAttribute("id","label_feature_rule");
	label_rule.setAttribute("for","select_feature_rule");
	var label = document.createTextNode("Select rule: ");
	label_rule.appendChild(label);
	div_result.appendChild(label_rule);
	
	var select_ways_rule = document.createElement("select");
	select_ways_rule.setAttribute("id","select_feature_rule");

	var rules_available = new Array(
		"<line style=\"stroke-width: 4px; stroke-linecap: round; stroke: #000000;\"/>",
		"<line style=\"stroke-width: 2px; stroke-linecap: round; stroke: #7FC97F;\"/>"
	);

			var new_option = document.createElement("option");
			new_option.setAttribute("value","Osmarender_frontend:null");
			var new_option_text = document.createTextNode("No rule");
			new_option.appendChild(new_option_text);
			select_ways_rule.appendChild(new_option);

	for (var rule in rules_available) {
			var new_option = document.createElement("option");
			new_option.setAttribute("value",rules_available[rule]);
			var new_option_text = document.createTextNode(rules_available[rule]);
			new_option.appendChild(new_option_text);
			select_ways_rule.appendChild(new_option);
	}
	
	div_result.appendChild(select_ways_rule);
	
}

function preProcessOsm() {
	elements["nodes"] = new Array();
	elements["ways"] = new Array();

	var osmfilename_written = document.getElementById("osm_file_name_written").value;
	var osmfilename_selected = document.getElementById("osm_file_name_selected").value;

	var osmfilename="data.osm";
	
	if (osmfilename_selected == "") {
		if (osmfilename_written != "") {
			osmfilename = osmfilename_written;
		}
	}
	else {
		osmfilename = osmfilename_selected;
	}

	osmfile = Sarissa.getDomDocument();
	osmfile.async=false;
	osmfile.load(osmfilename);

	nodes = osmfile.documentElement.selectNodes("//node");
	ways = osmfile.documentElement.selectNodes("//way");

	for (var nodes_counter = 0; nodes_counter < nodes.length; nodes_counter++) {
		var nodetags = nodes[nodes_counter].selectNodes("tag");
		var addmetags = elements["nodes"][nodes[nodes_counter].getAttribute("id")]=new Array();
		for (var nodetag_counter = 0; nodetag_counter < nodetags.length; nodetag_counter++) {
			addmetags[nodetags[nodetag_counter].getAttribute("k")] = nodetags[nodetag_counter].getAttribute("v");
		}
	}
/*	var stringa_da_stampare="";
	for (var dettaglio in elements.nodes) {
		for (var tag in elements.nodes[dettaglio])
		stringa_da_stampare+= "id: "+tag+" valore "+elements.nodes[dettaglio][tag]+"\r\n";
	}
	alert(stringa_da_stampare);*/

	for (var ways_counter = 0; ways_counter < ways.length; ways_counter++) {
		var waytags = ways[ways_counter].selectNodes("tag");
		var addmetags = elements["ways"][ways[ways_counter].getAttribute("id")]=new Array();
		for (var waytag_counter = 0; waytag_counter < waytags.length; waytag_counter++) {
			addmetags[waytags[waytag_counter].getAttribute("k")] = waytags[waytag_counter].getAttribute("v");
		}
	}
/*	var stringa_da_stampare="";
	for (var dettaglio in elements.ways) {
		for (var tag in elements.ways[dettaglio])
		stringa_da_stampare+= "id: "+tag+" valore "+elements.ways[dettaglio][tag]+"\r\n";
	}
	alert(stringa_da_stampare);*/
	
	var div_result = document.getElementById("result_process_osm");

	while (div_result.hasChildNodes()) {
		div_result.removeChild(div_result.firstChild);
	}

	var label_container = document.createElement("label");
	label_container.setAttribute("for","select_feature_way");
	var label = document.createTextNode("Select way feature: ");
	label_container.appendChild(label);
	div_result.appendChild(label_container);
	
	var select_ways_key = document.createElement("select");
	select_ways_key.setAttribute("id","select_feature_way");
	select_ways_key.setAttribute("onChange","javascript:viewValuesFromKey(this.value)");
	
	var sorted_list_of_unique_keys = new Array();
	
	for (var dettaglio in elements.ways) {
		for (var tag in elements.ways[dettaglio]) {
			sorted_list_of_unique_keys[sorted_list_of_unique_keys.length]=tag;
		}
	}
	
	sorted_list_of_unique_keys = RemoveDuplicates(sorted_list_of_unique_keys.sort());
	
	var new_option_null = document.createElement("option");
	new_option_null.setAttribute("value","osmarender_frontend:null");
	var new_option_null_text = document.createTextNode("Select a way feature");
	new_option_null.appendChild(new_option_null_text);
	select_ways_key.appendChild(new_option_null);

	for (var key_name in sorted_list_of_unique_keys) {
			var new_option = document.createElement("option");
			new_option.setAttribute("value",sorted_list_of_unique_keys[key_name]);
			var new_option_text = document.createTextNode(sorted_list_of_unique_keys[key_name]);
			new_option.appendChild(new_option_text);
			select_ways_key.appendChild(new_option);
	}
	
	div_result.appendChild(select_ways_key);
	
	document.getElementById("link_preprocess").setAttribute("style","display:none;");
	document.getElementById("link_clear_preprocess").setAttribute("style","display:block;");
}
function RemoveDuplicates(arr) {
	//get sorted array as input and returns the same array without duplicates.
	var result=new Array();
	var lastValue="";
	for (var i=0; i<arr.length; i++) {
		var curValue=arr[i];
		if (curValue != lastValue) {
			result[result.length] = curValue;
		}
		lastValue=curValue;
    }
    return result;
}

function Osmatranform() {
	var rulesfilename = document.getElementById("rules_file_name").value;

	rulesfile = Sarissa.getDomDocument();
	rulesfile.async=false;
	rulesfile.load(rulesfilename);

	var osmfilename_written = document.getElementById("osm_file_name_written").value;
	var osmfilename_selected = document.getElementById("osm_file_name_selected").value;

	var osmfilename="data.osm";
	
	if (osmfilename_selected == "") {
		if (osmfilename_written != "") {
			osmfilename = osmfilename_written;
		}
	}
	else {
		osmfilename = osmfilename_selected;
	}
	
	tags = rulesfile.getElementsByTagName("rules");
	tags[0].setAttribute("data",osmfilename);

	(document.getElementById("showScale").checked) ? tags[0].setAttribute("showScale","yes") : tags[0].setAttribute("showScale","no");
	(document.getElementById("showGrid").checked) ? tags[0].setAttribute("showGrid","yes") : tags[0].setAttribute("showGrid","no");
	(document.getElementById("showBorder").checked) ? tags[0].setAttribute("showBorder","yes") : tags[0].setAttribute("showBorder","no");
	(document.getElementById("showLicense").checked) ? tags[0].setAttribute("showLicense","yes") : tags[0].setAttribute("showLicense","no");
	(document.getElementById("interactive").checked) ? tags[0].setAttribute("interactive","yes") : tags[0].setAttribute("interactive","no");

	if (document.getElementById("select_feature_rule") && document.getElementById("select_feature_rule").getAttribute("value")!="Osmarender_frontend:null") {
		var new_rule=rulesfile.createElement("rule");
		new_rule.setAttribute("e","way");
		
		new_rule.setAttribute("k",(document.getElementById("select_feature_way").options[document.getElementById("select_feature_way").selectedIndex]).getAttribute("value"));
		new_rule.setAttribute("v",(document.getElementById("select_feature_value").options[document.getElementById("select_feature_value").selectedIndex]).getAttribute("value"));
		
		var add_rule = Sarissa.getDomDocument();
		add_rule = (new DOMParser()).parseFromString((document.getElementById("select_feature_rule").options[document.getElementById("select_feature_rule").selectedIndex]).getAttribute("value"), "text/xml");
		new_rule.appendChild(add_rule.documentElement);

		tag_rule = rulesfile.getElementsByTagName("rule");
		tag_rule[0].appendChild(new_rule);
	}
	
	xslfile = Sarissa.getDomDocument();
	xslfile.async=false;
	xslfile.load("osmarender.xsl");

	try{
			var processor = new XSLTProcessor();
			processor.importStylesheet(xslfile);
			var svgfile = processor.transformToDocument(rulesfile.documentElement);
			while (document.getElementById("svgfile").hasChildNodes()) {
				document.getElementById("svgfile").removeChild(document.getElementById("svgfile").firstChild);
			}
			var title_container = document.createElement("h1");
			var title = document.createTextNode("data file: "+osmfilename+" with rules: "+rulesfilename);
			title_container.appendChild(title);
			document.getElementById("svgfile").appendChild(title_container);
			document.getElementById("svgfile").appendChild(svgfile.documentElement);
	}
	catch (error) {
	  alert(error);
	}

}

function clearSVG(){
	while (document.getElementById("svgfile").hasChildNodes()) {
		document.getElementById("svgfile").removeChild(document.getElementById("svgfile").firstChild);
	}
}

function clearPreProcess() {
	while (document.getElementById("result_process_osm").hasChildNodes()) {
		document.getElementById("result_process_osm").removeChild(document.getElementById("result_process_osm").firstChild);
	}
	document.getElementById("link_preprocess").setAttribute("style","display:block;");
	document.getElementById("link_clear_preprocess").setAttribute("style","display:none;");
}
